
set_arg_frequencies(Head) :-
	determination(Head, phrase_contains_some_arg_10x_word/5),
	determination(Head, phrase_contains_some_arg_5x_word/5),
	determination(Head, phrase_contains_some_arg_2x_word/5),
	determination(Head, phrase_contains_some_arg_halfX_word/5),

	determination(Head, phrase_contains_no_arg_halfX_word/4),

	determination(Head, phrase_contains_several_arg_10x_word/4),
	determination(Head, phrase_contains_several_arg_5x_word/4),
	determination(Head, phrase_contains_several_arg_2x_word/4),

	determination(Head, phrase_contains_many_arg_10x_word/4),
	determination(Head, phrase_contains_many_arg_5x_word/4),
	determination(Head, phrase_contains_many_arg_2x_word/4),

	determination(Head, very_high_phrase_log_odds/3),
	determination(Head, high_phrase_log_odds/3),
	determination(Head, med_phrase_log_odds/3),
	determination(Head, positive_phrase_log_odds/3),

	true.


:- modeb(3, phrase_contains_some_arg_10x_word(   +phrase, #arg, #pos, -word, #fold)).
:- modeb(3, phrase_contains_some_arg_5x_word(    +phrase, #arg, #pos, -word, #fold)).
:- modeb(3, phrase_contains_some_arg_2x_word(    +phrase, #arg, #pos, -word, #fold)).
:- modeb(3, phrase_contains_some_arg_halfX_word( +phrase, #arg, #pos, -word, #fold)).
:- modeb(1,             phrase_contains_no_arg_halfX_word(   +phrase, #arg, #pos,        #fold)).

:- modeb(1, phrase_contains_several_arg_10x_word(+phrase, #arg, #pos,        #fold)).
:- modeb(1, phrase_contains_several_arg_5x_word( +phrase, #arg, #pos,        #fold)).
:- modeb(1, phrase_contains_several_arg_2x_word( +phrase, #arg, #pos,        #fold)).

:- modeb(1, phrase_contains_many_arg_10x_word(   +phrase, #arg, #pos,        #fold)).
:- modeb(1, phrase_contains_many_arg_5x_word(    +phrase, #arg, #pos,        #fold)).
:- modeb(1, phrase_contains_many_arg_2x_word(    +phrase, #arg, #pos,        #fold)).

:- modeb(1, very_high_phrase_log_odds(+phrase, #arg, #fold)).
:- modeb(1, high_phrase_log_odds(     +phrase, #arg, #fold)).
:- modeb(1, med_phrase_log_odds(      +phrase, #arg, #fold)).
:- modeb(1, positive_phrase_log_odds( +phrase, #arg, #fold)).

% Precompute all this stuff?  Add to pruners - to do 

phrase_contains_some_arg_10x_word(Phrase,   Arg, POS, Word, Fold) :- 
	count_arg_10x_word_in_phrase(Phrase, Arg, POS, Count, Fold), Count > 0, % Make sure this is a phrase worth checking.
	child(Phrase, Word), word_ID_to_string(Word, WordString), arg_10x_word(  WordString, Arg, Fold), wordPOS_extra(Word, POS), allow_this_POS_in_frequency_word(POS).
phrase_contains_some_arg_5x_word(Phrase,    Arg, POS, Word, Fold) :- 
	count_arg_5x_word_in_phrase( Phrase, Arg, POS, Count, Fold), Count > 0,
	child(Phrase, Word), word_ID_to_string(Word, WordString), arg_5x_word(   WordString, Arg, Fold), wordPOS_extra(Word, POS), allow_this_POS_in_frequency_word(POS).
phrase_contains_some_arg_2x_word(Phrase,    Arg, POS, Word, Fold) :- 
	count_arg_2x_word_in_phrase( Phrase, Arg, POS, Count, Fold), Count > 0,
	child(Phrase, Word), word_ID_to_string(Word, WordString), arg_2x_word(   WordString, Arg, Fold), wordPOS_extra(Word, POS), allow_this_POS_in_frequency_word(POS).
phrase_contains_some_arg_halfX_word(Phrase, Arg, POS, Word, Fold) :- 
	child(Phrase, Word), word_ID_to_string(Word, WordString), arg_halfX_word(WordString, Arg, Fold), wordPOS_extra(Word, POS), allow_this_POS_in_frequency_word(POS).
phrase_contains_no_arg_halfX_word(Phrase,   Arg, POS, Fold)       :-
	not phrase_contains_some_arg_halfX_word(Phrase, Arg, POS, _, Fold).

phrase_contains_several_arg_10x_word(Phrase, Arg, POS,        Fold) :-
	count_arg_10x_word_in_phrase(Phrase, Arg, POS, Count, Fold), Count > 1.
phrase_contains_several_arg_5x_word( Phrase, Arg, POS,        Fold) :-
	count_arg_5x_word_in_phrase( Phrase, Arg, POS, Count, Fold), Count > 1.
phrase_contains_several_arg_2x_word( Phrase, Arg, POS,        Fold) :-
	count_arg_2x_word_in_phrase( Phrase, Arg, POS, Count, Fold), Count > 1.

phrase_contains_many_arg_10x_word(   Phrase, Arg, POS,        Fold) :-
	count_arg_10x_word_in_phrase(Phrase, Arg, POS, Count, Fold), Count > 3.
phrase_contains_many_arg_5x_word(    Phrase, Arg, POS,        Fold) :-
	count_arg_5x_word_in_phrase( Phrase, Arg, POS, Count, Fold), Count > 3.
phrase_contains_many_arg_2x_word(    Phrase, Arg, POS,        Fold) :-
	count_arg_2x_word_in_phrase( Phrase, Arg, POS, Count, Fold), Count > 3.

