set_between_arg_frequencies(Head) :-

	determination(Head, phrase_contains_some_between_10x_word/5),
	determination(Head, phrase_contains_some_between_5x_word/5),
	determination(Head, phrase_contains_some_between_2x_word/5),
	determination(Head, phrase_contains_some_between_halfX_word/5),

	determination(Head, phrase_contains_no_between_halfX_word/4),

	determination(Head, phrase_contains_several_between_10x_word/4),
	determination(Head, phrase_contains_several_between_5x_word/4),
	determination(Head, phrase_contains_several_between_2x_word/4),

	determination(Head, phrase_contains_many_between_10x_word/4),
	determination(Head, phrase_contains_many_between_5x_word/4),
	determination(Head, phrase_contains_many_between_2x_word/4),

	true.


:- modeb(3, phrase_contains_some_between_10x_word(   +phrase, #arg, #pos, -word, #fold)).
:- modeb(3, phrase_contains_some_between_5x_word(    +phrase, #arg, #pos, -word, #fold)).
:- modeb(3, phrase_contains_some_between_2x_word(    +phrase, #arg, #pos, -word, #fold)).
:- modeb(3, phrase_contains_some_between_halfX_word( +phrase, #arg, #pos, -word, #fold)).
:- modeb(1,             phrase_contains_no_between_halfX_word(   +phrase, #arg, #pos,        #fold)).

:- modeb(1, phrase_contains_several_between_10x_word(+phrase, #arg, #pos,        #fold)).
:- modeb(1, phrase_contains_several_between_5x_word( +phrase, #arg, #pos,        #fold)).
:- modeb(1, phrase_contains_several_between_2x_word( +phrase, #arg, #pos,        #fold)).

:- modeb(1, phrase_contains_many_between_10x_word(   +phrase, #arg, #pos,        #fold)).
:- modeb(1, phrase_contains_many_between_5x_word(    +phrase, #arg, #pos,        #fold)).
:- modeb(1, phrase_contains_many_between_2x_word(    +phrase, #arg, #pos,        #fold)).

% Precompute all this stuff?  Add to pruners

phrase_contains_some_between_10x_word(Phrase,   Arg, POS, Word, Fold) :- 
	count_between_10x_word_in_phrase(Phrase, Arg, POS, Count, Fold), Count > 0,
	child(Phrase, Word), word_ID_to_string(Word, WordString), between_10x_word(  WordString, Arg, Fold), wordPOS_extra(Word, POS), allow_this_POS_in_frequency_word(POS).
phrase_contains_some_between_5x_word(Phrase,    Arg, POS, Word, Fold) :- 
	count_between_5x_word_in_phrase(Phrase, Arg, POS, Count, Fold), Count > 0,
	child(Phrase, Word), word_ID_to_string(Word, WordString), between_5x_word(   WordString, Arg, Fold), wordPOS_extra(Word, POS), allow_this_POS_in_frequency_word(POS).
phrase_contains_some_between_2x_word(Phrase,    Arg, POS, Word, Fold) :- 
	count_between_2x_word_in_phrase(Phrase, Arg, POS, Count, Fold), Count > 0,
	child(Phrase, Word), word_ID_to_string(Word, WordString), between_2x_word(   WordString, Arg, Fold), wordPOS_extra(Word, POS), allow_this_POS_in_frequency_word(POS).
phrase_contains_some_between_halfX_word(Phrase, Arg, POS, Word, Fold) :- 
	child(Phrase, Word), word_ID_to_string(Word, WordString), between_halfX_word(WordString, Arg, Fold), wordPOS_extra(Word, POS), allow_this_POS_in_frequency_word(POS).
phrase_contains_no_between_halfX_word(Phrase,   Arg, POS, Fold) :-
	not phrase_contains_some_between_halfX_word(Phrase, Arg, POS, _, Fold).

phrase_contains_several_between_10x_word(Phrase, Arg, POS,        Fold) :-
	count_between_10x_word_in_phrase(Phrase, Arg, POS, Count, Fold), Count > 1.
phrase_contains_several_between_5x_word( Phrase, Arg, POS,        Fold) :-
	count_between_5x_word_in_phrase( Phrase, Arg, POS, Count, Fold), Count > 1.
phrase_contains_several_between_2x_word( Phrase, Arg, POS,        Fold) :-
	count_between_2x_word_in_phrase( Phrase, Arg, POS, Count, Fold), Count > 1.

phrase_contains_many_between_10x_word(   Phrase, Arg, POS,        Fold) :-
	count_between_10x_word_in_phrase(Phrase, Arg, POS, Count, Fold), Count > 3.
phrase_contains_many_between_5x_word(    Phrase, Arg, POS,        Fold) :-
	count_between_5x_word_in_phrase( Phrase, Arg, POS, Count, Fold), Count > 3.
phrase_contains_many_between_2x_word(    Phrase, Arg, POS,        Fold) :-
	count_between_2x_word_in_phrase( Phrase, Arg, POS, Count, Fold), Count > 3.

