:- modeb(1, pp_segment(     +phrase)).
:- modeb(1, vp_segment(     +phrase)).
:- modeb(1, adj_segment(    +phrase)).
%:-modeb(1, np_segment(     +phrase)). % These are all merged into isa_np_segment (might not be a good idea, but cuts down on search space).
%:-modeb(1, np_conj_segment(+phrase)). % Ditto.
:- modeb(1, isa_np_segment( +phrase)).

:- modeb(1, c_m( +phrase)). % These are weird names for phrase properties.  Used for single-word phrases?
:- modeb(1, art( +phrase)).
:- modeb(1, adj( +phrase)).
:- modeb(1, prep(+phrase)).
:- modeb(1, conj(+phrase)).
:- modeb(1, adv( +phrase)).
%:-modeb(1, n(   +phrase)).
:- modeb(1, lex( +phrase)).
:- modeb(1, part(+phrase)).
:- modeb(1, v(   +phrase)).

% Group noun phrases.
isa_np_segment(X) :- np_conj_segment(X).
isa_np_segment(X) :- np_segment(X).
isa_np_segment(X) :- n(X), phrase(X).  % Apparently used if the noun phrase is a single word.

isa_key_arg_in_target(arg1).
isa_key_arg_in_target(arg2).
isa_between_arg_in_target(between_arg1_and_arg2).

marked_up_arg(Word, SpecificWord, arg1, Fold) :-  % to do - count these per phrase!
	word_ID_to_string(Word, SpecificWord),
	multiply_marked_up_arg1(SpecificWord, Fold).
marked_up_arg(Word, SpecificWord, arg2, Fold) :-
	word_ID_to_string(Word, SpecificWord),
	multiply_marked_up_arg2(SpecificWord, Fold).

%to add: phrase_contains_many_go_terms ...  sentence_contains_many_go_terms

% Some bio-specific predicates.
:- modeb(3, phrase_contains_go_term(     +phrase, -string, -string, -word)).
:- modeb(3, phrase_contains_medDict_term(+phrase, -string, -string, -word)).
:- modeb(3, phrase_contains_mesh_term(   +phrase, -string, -string, -word)).
:- modeb(3, phrase_contains_mesh_protein(+phrase, -string, -string, -word)).
:- modeb(3, phrase_contains_mesh_peptide(+phrase, -string, -string, -word)).
:- modeb(3, phrase_contains_mesh_cellular_structure(+phrase, -string, -string, -word)). 
:- modeb(3, phrase_contains_go_term(     +phrase, #string, #string, -word)).
:- modeb(3, phrase_contains_medDict_term(+phrase, #string, #string, -word)).
:- modeb(3, phrase_contains_mesh_term(   +phrase, #string, #string, -word)).
:- modeb(3, phrase_contains_mesh_protein(+phrase, #string, #string, -word)).
:- modeb(3, phrase_contains_mesh_peptide(+phrase, #string, #string, -word)).
:- modeb(3, phrase_contains_mesh_cellular_structure(+phrase, #string,  #string, -word)). 

:- mode(1, marked_up_arg(+word, -string, #arg, #fold)).
:- mode(1, marked_up_arg(+word, #string, #arg, #fold)).

:- modeb(3, phrase_contains_some_prep(+phrase, -word)).
:- modeb(3, phrase_contains_some_art( +phrase, -word)).
:- modeb(3, phrase_contains_some_adj( +phrase, -word)).
:- modeb(3, phrase_contains_some_n(   +phrase, -word)).
:- modeb(3, phrase_contains_some_v(   +phrase, -word)).
:- modeb(3, phrase_contains_some_cop( +phrase, -word)).
:- modeb(3, phrase_contains_some_det( +phrase, -word)).
:- modeb(3, phrase_contains_some_unk( +phrase, -word)).
:- modeb(3, phrase_contains_some_pn(  +phrase, -word)).
:- modeb(3, phrase_contains_some_adv( +phrase, -word)).
:- modeb(3, phrase_contains_some_c_m( +phrase, -word)).
:- modeb(3, phrase_contains_some_num( +phrase, -word)).
:- modeb(3, phrase_contains_some_ger( +phrase, -word)).
:- modeb(3, phrase_contains_some_inf( +phrase, -word)).
:- modeb(3, phrase_contains_some_conj(+phrase, -word)).
:- modeb(3, phrase_contains_some_aux( +phrase, -word)).
:- modeb(3, phrase_contains_some_lex( +phrase, -word)).
:- modeb(3, phrase_contains_some_part(+phrase, -word)).
:- modeb(3, phrase_contains_some_part(+phrase, -word)).

:- modeb(7, phrase_contains_some_marked_up_arg(+phrase, #arg, -word, #fold)).

:- modeb(3, phrase_contains_some_unknown_word(      +phrase, -pos, -word)).
:- modeb(3, phrase_contains_some_alphabetic(        +phrase, -pos, -word)).
:- modeb(5, phrase_contains_some_alphanumeric(      +phrase, -pos, -word)).
:- modeb(5, phrase_contains_some_numeric(           +phrase, -pos, -word)).
:- modeb(3, phrase_contains_some_singlechar_word(   +phrase, -pos, -word)).
:- modeb(5, phrase_contains_some_hyphenated_word(   +phrase, -pos, -word)).
:- modeb(3, phrase_contains_some_unknown_word(      +phrase, -pos, -word)).
:- modeb(5, phrase_contains_some_all_caps_word(     +phrase, -pos, -word)).
:- modeb(5, phrase_contains_some_leading_cap_word(  +phrase, -pos, -word)).
:- modeb(5, phrase_contains_some_internal_cap_word( +phrase, -pos, -word)).
:- modeb(3, phrase_contains_some_alphabetic(        +phrase, #pos, -word)).
:- modeb(5, phrase_contains_some_alphanumeric(      +phrase, #pos, -word)).
:- modeb(5, phrase_contains_some_numeric(           +phrase, #pos, -word)).
:- modeb(3, phrase_contains_some_singlechar_word(   +phrase, #pos, -word)).
:- modeb(5, phrase_contains_some_hyphenated_word(   +phrase, #pos, -word)).
:- modeb(5, phrase_contains_some_all_caps_word(     +phrase, #pos, -word)).
:- modeb(5, phrase_contains_some_leading_cap_word(  +phrase, #pos, -word)).
:- modeb(5, phrase_contains_some_internal_cap_word( +phrase, #pos, -word)).

%old :- modeb(5, phrase_contains_some_cell_location_word(+phrase, -pos, -word)).
%old :- modeb(5, phrase_contains_some_med_dict_word(     +phrase, -pos, -word)).
%old :- modeb(5, phrase_contains_some_cell_location_word(+phrase, #pos, -word)).
%old :- modeb(5, phrase_contains_some_med_dict_word(     +phrase, #pos, -word)).

phrase_contains_some_prep(Phrase, Word) :- phrase_child(Phrase, Word), prep(Word).
phrase_contains_some_art( Phrase, Word) :- phrase_child(Phrase, Word), art(Word).
phrase_contains_some_adj( Phrase, Word) :- phrase_child(Phrase, Word), adj(Word).
phrase_contains_some_n(   Phrase, Word) :- phrase_child(Phrase, Word), n(Word).
phrase_contains_some_v(   Phrase, Word) :- phrase_child(Phrase, Word), v(Word).
phrase_contains_some_cop( Phrase, Word) :- phrase_child(Phrase, Word), cop(Word).
phrase_contains_some_det( Phrase, Word) :- phrase_child(Phrase, Word), det(Word).
phrase_contains_some_unk( Phrase, Word) :- phrase_child(Phrase, Word), unk(Word).
phrase_contains_some_pn(  Phrase, Word) :- phrase_child(Phrase, Word), pn(Word).
phrase_contains_some_adv( Phrase, Word) :- phrase_child(Phrase, Word), adv(Word).
phrase_contains_some_c_m( Phrase, Word) :- phrase_child(Phrase, Word), c_m(Word).
phrase_contains_some_num( Phrase, Word) :- phrase_child(Phrase, Word), num(Word).
phrase_contains_some_ger( Phrase, Word) :- phrase_child(Phrase, Word), ger(Word).
phrase_contains_some_inf( Phrase, Word) :- phrase_child(Phrase, Word), inf(Word).
phrase_contains_some_conj(Phrase, Word) :- phrase_child(Phrase, Word), conj(Word).
phrase_contains_some_aux( Phrase, Word) :- phrase_child(Phrase, Word), aux(Word).
phrase_contains_some_lex( Phrase, Word) :- phrase_child(Phrase, Word), lex(Word).
phrase_contains_some_part(Phrase, Word) :- phrase_child(Phrase, Word), part(Word).

phrase_contains_some_marked_up_arg(Phrase, Arg, Word, Fold) :-
	isa_key_arg_in_target(Arg), child(Phrase, Word), marked_up_arg(Word, _, Arg, Fold).

phrase_contains_some_unknown_word(   Phrase, POS, Word) :- child(Phrase, Word), unknown_word(Word),      wordPOS(Word, POS).
phrase_contains_some_novel_word(     Phrase, POS, Word) :- child(Phrase, Word), novel_word(Word),        wordPOS(Word, POS).
phrase_contains_some_alphabetic(     Phrase, POS, Word) :- child(Phrase, Word), alphabetic(Word),        wordPOS(Word, POS).
phrase_contains_some_alphanumeric(   Phrase, POS, Word) :- child(Phrase, Word), alphanumeric(Word),      wordPOS(Word, POS).
phrase_contains_some_numeric(        Phrase, POS, Word) :- child(Phrase, Word), numeric(Word),           wordPOS(Word, POS).
phrase_contains_some_singlechar_word(Phrase, POS, Word) :- child(Phrase, Word), singlecharword(Word),    wordPOS(Word, POS).
phrase_contains_some_hyphenated_word(Phrase, POS, Word) :- child(Phrase, Word), hyphenated(Word),        wordPOS(Word, POS).
phrase_contains_some_all_caps_word(    Phrase, POS, Word) :- child(Phrase, Word), originally_all_caps(    Word), wordPOS(Word, POS).
phrase_contains_some_leading_cap_word( Phrase, POS, Word) :- child(Phrase, Word), originally_internal_cap(Word), wordPOS(Word, POS).
phrase_contains_some_internal_cap_word(Phrase, POS, Word) :- child(Phrase, Word), originally_leading_cap( Word), wordPOS(Word, POS).
%old phrase_contains_some_cell_location_word(Phrase, POS, Word) :- child(Phrase, Word), cell_location(Word),  wordPOS(Word, POS).
%old phrase_contains_some_med_dict_word(     Phrase, POS, Word) :- child(Phrase, Word), medDict(Word),        wordPOS(Word, POS).


% Provide a way to generate all the parts of speech (and the like). 
% Should match up with wordPOS().  However, alphabetic is skipped.
isa_wordPOS_tag(alphabetic). % Call these POS for simplicity.
isa_wordPOS_tag(alphanumeric).
isa_wordPOS_tag(numeric).
isa_wordPOS_tag(singlecharword).
isa_wordPOS_tag(hyphenated). 
%isa_wordPOS_tag(unknown_word). % Could merge the next two under this.
isa_wordPOS_tag(novelword). 
isa_wordPOS_tag(originally_leading_cap). 
isa_wordPOS_tag(originally_internal_cap). 
isa_wordPOS_tag(originally_all_caps). 
isa_wordPOS_tag(unk).
isa_wordPOS_tag(cell_location).
isa_wordPOS_tag(in_medical_dict).
isa_wordPOS_tag(prep).
isa_wordPOS_tag(art).
isa_wordPOS_tag(adj).
isa_wordPOS_tag(noun).
isa_wordPOS_tag(verb).
isa_wordPOS_tag(cop).
isa_wordPOS_tag(det).
isa_wordPOS_tag(pn).
isa_wordPOS_tag(adv).
isa_wordPOS_tag(c_m).
isa_wordPOS_tag(num).
isa_wordPOS_tag(ger).
isa_wordPOS_tag(inf).
isa_wordPOS_tag(conj).
isa_wordPOS_tag(aux).
isa_wordPOS_tag(lex).
isa_wordPOS_tag(part).
isa_wordPOS_tag(wild_card).

isa_frequent_POS_tag(alphabetic).
isa_frequent_POS_tag(noun).
isa_frequent_POS_tag(verb).
isa_frequent_POS_tag(adj).
isa_frequent_POS_tag(adv).
isa_frequent_POS_tag(novelword).
isa_frequent_POS_tag(unk).

% Allow POS tags to specified in a different manner.
wordPOS(Word, prep) :- prep(Word), word(Word).
wordPOS(Word,  art) :- art( Word), word(Word).
wordPOS(Word,  adj) :- adj( Word), word(Word).
wordPOS(Word, noun) :- n(   Word), word(Word).
wordPOS(Word, verb) :- v(   Word), word(Word).
wordPOS(Word,  cop) :- cop( Word), word(Word).
wordPOS(Word,  det) :- det( Word), word(Word).
wordPOS(Word,  unk) :- unk( Word), word(Word).
wordPOS(Word,  pn)  :- pn(  Word), word(Word).
wordPOS(Word,  adv) :- adv( Word), word(Word).
wordPOS(Word,  c_m) :- c_m( Word), word(Word).
wordPOS(Word,  num) :- num( Word), word(Word).
wordPOS(Word,  ger) :- ger( Word), word(Word).
wordPOS(Word,  inf) :- inf( Word), word(Word).
wordPOS(Word, conj) :- conj(Word), word(Word).
wordPOS(Word,  aux) :- aux( Word), word(Word).
wordPOS(Word,  lex) :- lex( Word), word(Word).
wordPOS(Word, part) :- part(Word), word(Word).
wordPOS(Word, novelword)      :- novelword(     Word), word(Word).
%wordPOS(Word,alphabetic)     :- alphabetic(    Word), word(Word). % Too many combinatorics if included.
wordPOS(Word, alphanumeric)   :- alphanumeric(  Word), word(Word). % Call these POS's, even if that's not quite true.
wordPOS(Word, numeric)        :- numeric(       Word), word(Word).
wordPOS(Word, singlecharword) :- singlecharword(Word), word(Word).
wordPOS(Word, hyphenated)     :- hyphenated(    Word), word(Word).
wordPOS(Word, originally_leading_cap)  :- originally_leading_cap( Word), word(Word).
wordPOS(Word, originally_internal_cap) :- originally_internal_cap(Word), word(Word).
wordPOS(Word, originally_all_caps)     :- originally_all_caps(    Word), word(Word). 
%old wordPOS(Word, cell_location)  :- cell_location( Word), word(Word).
%old wordPOS(Word, in_medical_dict):- medDict(       Word), word(Word).

%unknown_word(Word) :- once( (novelword(Word) ; unk(Word)) ), word(Word). % Could combine these two.  Structure so dont get two proofs.
%wordPOS(Word, unknown_word) :- unknown_word(Word), word(Word).

wordPOS_extra(Word, POS)       :- wordPOS(Word, POS).
wordPOS_extra(Word, wild_card) :- word(Word), wordPOS(Word, POS), acceptable_wild_cardPOS(POS). % Write '*' w/o needing quotes.

word_ID_to_string_extra(Word, String)    :- word_ID_to_string(Word, String).
word_ID_to_string_extra(Word, wild_card) :- word(Word).


isa_phrasePOS_tag(pp_segment).
isa_phrasePOS_tag(np_segment).
isa_phrasePOS_tag(vp_segment).
isa_phrasePOS_tag(np_conj_segment).
isa_phrasePOS_tag(adj_segment).
isa_phrasePOS_tag(isa_np_segment).
isa_phrasePOS_tag(c_m).
isa_phrasePOS_tag(art).
isa_phrasePOS_tag(prep).
isa_phrasePOS_tag(conj).
isa_phrasePOS_tag(adv).
isa_phrasePOS_tag(n).
isa_phrasePOS_tag(lex).
isa_phrasePOS_tag(part).
isa_phrasePOS_tag(v).

phrasePOS(Phrase, pp_segment)      :- pp_segment(     Phrase), phrase(Phrase).
phrasePOS(Phrase, np_segment)      :- np_segment(     Phrase), phrase(Phrase).
phrasePOS(Phrase, vp_segment)      :- vp_segment(     Phrase), phrase(Phrase).
phrasePOS(Phrase, np_conj_segment) :- np_conj_segment(Phrase), phrase(Phrase).
phrasePOS(Phrase, adj_segment)     :- adj_segment(    Phrase), phrase(Phrase).
phrasePOS(Phrase, isa_np_segment)  :- isa_np_segment( Phrase), phrase(Phrase).

phrasePOS(Phrase, c_m)  :- c_m( Phrase), phrase(Phrase).
phrasePOS(Phrase, art)  :- art( Phrase), phrase(Phrase).
phrasePOS(Phrase, adj)  :- adj( Phrase), phrase(Phrase).
phrasePOS(Phrase, prep) :- prep(Phrase), phrase(Phrase).
phrasePOS(Phrase, conj) :- conj(Phrase), phrase(Phrase).
phrasePOS(Phrase, adv)  :- adv( Phrase), phrase(Phrase).
phrasePOS(Phrase, n)    :- n(   Phrase), phrase(Phrase).
phrasePOS(Phrase, lex)  :- lex( Phrase), phrase(Phrase).
phrasePOS(Phrase, part) :- part(Phrase), phrase(Phrase).
phrasePOS(Phrase, v)    :- v(   Phrase), phrase(Phrase).


map_any_ID_to_string(ID, String) :- sentence(ID), sentence_ID_to_string(ID, String), !.
map_any_ID_to_string(ID, String) :- phrase(  ID), phrase_ID_to_string(  ID, String), !.
map_any_ID_to_string(ID, String) :- word(    ID), word_ID_to_string(    ID, String), !.
map_any_ID_to_string(ID, 'unknownSentenceID') :- sentence(ID), !.
map_any_ID_to_string(ID, 'unknownPhraseID')   :- phrase(  ID), !.
map_any_ID_to_string(ID, 'unknownWordID')     :- word(    ID), !.

word_ID_to_string(ID, String) :-
	(uw_setting(use_stemmed_words, true) -> word_ID_to_string(  ID, _, String)
					      ;  word_ID_to_string(  ID, String, _), not(String = 'ignore_me')).
phrase_ID_to_string(ID, String) :-
	(uw_setting(use_stemmed_words, true) -> phrase_ID_to_string(ID, _, String)
					      ;  phrase_ID_to_string(ID, String, _), not(String = 'ignore_me')).

:- modeb(1, phrase_ID_to_string(        +phrase, #string)).
:- modeb(1, phrase_ID_to_string(+phrase, #string)).
:- modeb(1, word_ID_to_string(          +word,   #string)).
:- modeb(1, word_ID_to_string(  +word,   #string)).

allow_this_POS_in_frequency_word(POS) :-
	isa_wordPOS_tag(POS), % These are likely to overfit.
	POS \== alphanumeric, POS \== numeric, POS \== novelword, 
	POS \== originally_all_caps, POS \== originally_internal_cap,
	POS \== unk,          POS \== unknown_word.

acceptable_wild_cardPOS(POS) :- allow_this_POS_in_frequency_word(POS).


:- modeb(1, very_rare_word(        +word, #fold)).
:- modeb(1, rare_word(             +word, #fold)).
:- modeb(1, uncommon_word(         +word, #fold)).
:- modeb(1, common_word(           +word, #fold)).
:- modeb(1, very_common_word(      +word, #fold)).

:- modeb(1, only_in_one_sentence(  +word, #fold)).
:- modeb(1, only_in_one_abstract(  +word, #fold)).

:- modeb(1, in_few_sentences(      +word, #fold)).
:- modeb(1, in_few_abstracts(      +word, #fold)).

:- modeb(1, in_several_sentences(  +word, #fold)).
:- modeb(1, in_several_abstracts(  +word, #fold)).

:- modeb(1, in_many_sentences(     +word, #fold)).
:- modeb(1, in_many_abstracts(     +word, #fold)).

:- modeb(1, in_very_many_sentences(+word, #fold)).
:- modeb(1, in_very_many_abstracts(+word, #fold)).


set_lexical_determinations(Head) :-  % Note: sometimes these are also labeled as POS's for simplicity (and it doesnt seem to be a stretch of the meaning).

  determination(Head, very_rare_word/2),
  determination(Head, rare_word/2),
  determination(Head, uncommon_word/2),
  determination(Head, common_word/2),
  determination(Head, very_common_word/2),
  determination(Head, only_in_one_sentence/2),
  determination(Head, in_few_sentences/2),
  determination(Head, only_in_one_abstract/2),
  determination(Head, in_few_abstracts/2),
  determination(Head, in_several_sentences/2),
  determination(Head, in_many_sentences/2),
  determination(Head, in_very_many_sentences/2),
  determination(Head, in_several_abstracts/2),
  determination(Head, in_many_abstracts/2),
  determination(Head, in_very_many_abstracts/2),

% determination(Head, phrase_contains_some_unknown_word/3),
  determination(Head, phrase_contains_some_novel_word/3),
  determination(Head, phrase_contains_some_alphabetic/3),
  determination(Head, phrase_contains_some_alphanumeric/3),
  determination(Head, phrase_contains_some_numeric/3),
  determination(Head, phrase_contains_some_singlechar_word/3),
  determination(Head, phrase_contains_some_all_caps_word/3),
  determination(Head, phrase_contains_some_leading_cap_word/3),
  determination(Head, phrase_contains_some_internal_cap_word/3),
%old  determination(Head, phrase_contains_some_cell_location_word/3),
%old  determination(Head, phrase_contains_some_med_dict_word/3),

  determination(Head, phrase_contains_go_term/4),
  determination(Head, phrase_contains_medDict_term/4),
  determination(Head, phrase_contains_mesh_term/4),
  determination(Head, phrase_contains_mesh_protein/4),
  determination(Head, phrase_contains_mesh_peptide/4),
  determination(Head, phrase_contains_mesh_cellular_structure/4),

% determination(Head, phrase_ID_to_string/2), % Handled by phrase_contains_specific_word
% determination(Head, word_ID_to_string/2),
  true.

set_pos_determinations(Head) :-  
  determination(Head, pp_segment/1),
  determination(Head, np_segment/1),
  determination(Head, vp_segment/1),
  determination(Head, np_conj_segment/1),
  determination(Head, adj_segment/1),
  determination(Head, c_m/1),
  determination(Head, art/1),
  determination(Head, adj/1),
  determination(Head, prep/1),
  determination(Head, conj/1),
  determination(Head, adv/1),
  determination(Head, n/1),
  determination(Head, lex/1),
  determination(Head, part/1),
  determination(Head, v/1),

  determination(Head, isa_np_segment/1),

  determination(Head, marked_up_arg/4),

  determination(Head, phrase_contains_some_prep/2),
  determination(Head, phrase_contains_some_art/2),
  determination(Head, phrase_contains_some_adj/2),
  determination(Head, phrase_contains_some_n/2),
  determination(Head, phrase_contains_some_v/2),
  determination(Head, phrase_contains_some_cop/2),
  determination(Head, phrase_contains_some_det/2),
  determination(Head, phrase_contains_some_unk/2),
  determination(Head, phrase_contains_some_pn/2),
  determination(Head, phrase_contains_some_adv/2),
  determination(Head, phrase_contains_some_c_m/2),
  determination(Head, phrase_contains_some_num/2),
  determination(Head, phrase_contains_some_ger/2),
  determination(Head, phrase_contains_some_inf/2),
  determination(Head, phrase_contains_some_conj/2),
  determination(Head, phrase_contains_some_aux/2),
  determination(Head, phrase_contains_some_lex/2),
  determination(Head, phrase_contains_some_part/2),

  determination(Head, phrase_contains_some_marked_up_arg/4),  % Too likely to overfit?


  true.
