
:- modeb(1, first_word_in_phrase(    +phrase,   -word)).
:- modeb(1, last_word_in_phrase(     +phrase,   -word)).
:- modeb(1, first_phrase_in_sentence(+sentence, -phrase)).
:- modeb(1, last_phrase_in_sentence( +sentence, -phrase)).

short_phrase( Phrase) :- phrase_length(Phrase, Length), Length =< 3.
medium_phrase(Phrase) :- phrase_length(Phrase, Length), Length >  3 , Length < 7.
long_phrase(  Phrase) :- phrase_length(Phrase, Length), Length >= 7.

short_sentence(     Sentence) :- number_words_in_sentence(Sentence, Count),                Count < 10.
avg_length_sentence(Sentence) :- number_words_in_sentence(Sentence, Count), Count >=  10 , Count < 30.
long_sentence(      Sentence) :- number_words_in_sentence(Sentence, Count), Count >=  30.

few_phrases_in_sentence(    Sentence) :- number_phrases_in_sentence(Sentence, Count),               Count <  6.
several_phrases_in_sentence(Sentence) :- number_phrases_in_sentence(Sentence, Count), Count >=  6 , Count < 18.
many_phrases_in_sentence(   Sentence) :- number_phrases_in_sentence(Sentence, Count), Count >= 18.


:- modeb(1, short_phrase( +phrase)).
:- modeb(1, medium_phrase(+phrase)).
:- modeb(1, long_phrase(  +phrase)).

:- modeb(1, short_sentence(     +sentence)).
:- modeb(1, avg_length_sentence(+sentence)).
:- modeb(1, long_sentence(      +sentence)).

:- modeb(1, few_phrases_in_sentence(    +sentence)).
:- modeb(1, several_phrases_in_sentence(+sentence)).
:- modeb(1, many_phrases_in_sentence(   +sentence)).

no_POS_in_phrase(  Phrase, POS) :-    phraseCountPOS(Phrase, POS, Count), Count == 0.
one_POS_in_phrase( Phrase, POS) :-    phraseCountPOS(Phrase, POS, Count), Count == 1.
few_POS_in_phrase( Phrase, POS) :-    phraseCountPOS(Phrase, POS, Count), Count >  0, Count =< 2.
some_POS_in_phrase(Phrase, POS) :-    phraseCountPOS(Phrase, POS, Count), Count >  2, Count =< 5.
many_POS_in_phrase(Phrase, POS) :-    phraseCountPOS(Phrase, POS, Count), Count >  5.

:- modeb(1, no_POS_in_phrase(  +phrase , #pos)).
:- modeb(1, one_POS_in_phrase( +phrase , #pos)).
:- modeb(1, few_POS_in_phrase( +phrase , #pos)).
:- modeb(1, some_POS_in_phrase(+phrase , #pos)).
:- modeb(1, many_POS_in_phrase(+phrase , #pos)).

no_wordPOS_in_sentence(  Sentence, POS) :- sentenceCountWordPOS(Sentence, POS, Count), Count == 0.
one_wordPOS_in_sentence( Sentence, POS) :- sentenceCountWordPOS(Sentence, POS, Count), Count == 1.
few_wordPOS_in_sentence( Sentence, POS) :- sentenceCountWordPOS(Sentence, POS, Count), Count >  0, Count =< 3.
some_wordPOS_in_sentence(Sentence, POS) :- sentenceCountWordPOS(Sentence, POS, Count), Count >  3, Count =< 7.
many_wordPOS_in_sentence(Sentence, POS) :- sentenceCountWordPOS(Sentence, POS, Count), Count >  8.

:- modeb(1, no_wordPOS_in_sentence(  +sentence , #pos)).
:- modeb(1, one_wordPOS_in_sentence( +sentence , #pos)).
:- modeb(1, few_wordPOS_in_sentence( +sentence , #pos)).
:- modeb(1, some_wordPOS_in_sentence(+sentence , #pos)).
:- modeb(1, many_wordPOS_in_sentence(+sentence , #pos)).

no_phrasePOS_in_sentence(  Sentence, POS) :- sentenceCountPhrasePOS(Sentence, POS, Count), Count == 0.
one_phrasePOS_in_sentence( Sentence, POS) :- sentenceCountPhrasePOS(Sentence, POS, Count), Count == 1.
few_phrasePOS_in_sentence( Sentence, POS) :- sentenceCountPhrasePOS(Sentence, POS, Count), Count >  0, Count =< 2.
some_phrasePOS_in_sentence(Sentence, POS) :- sentenceCountPhrasePOS(Sentence, POS, Count), Count >  2, Count =< 5.
many_phrasePOS_in_sentence(Sentence, POS) :- sentenceCountPhrasePOS(Sentence, POS, Count), Count >  5.

:- modeb(1, no_phrasePOS_in_sentence(  +sentence , #pos)).
:- modeb(1, one_phrasePOS_in_sentence( +sentence , #pos)).
:- modeb(1, few_phrasePOS_in_sentence( +sentence , #pos)).
:- modeb(1, some_phrasePOS_in_sentence(+sentence , #pos)).
:- modeb(1, many_phrasePOS_in_sentence(+sentence , #pos)).

% This can be deduced other ways, but add them anyway.
adjacent_target_args(            ExampleID, Fold) :- phrases_between_target_args(ExampleID, Fold, 0).

few_phrases_before_target_args(  ExampleID, Fold) :- phrases_before_target_args( ExampleID, Fold, Count), Count > 0, Count =< 2.
some_phrases_before_target_args( ExampleID, Fold) :- phrases_before_target_args( ExampleID, Fold, Count), Count > 2, Count =< 5.
many_phrases_before_target_args( ExampleID, Fold) :- phrases_before_target_args( ExampleID, Fold, Count), Count > 5.

few_phrases_between_target_args( ExampleID, Fold) :- phrases_between_target_args(ExampleID, Fold, Count), Count > 0, Count =< 2.
some_phrases_between_target_args(ExampleID, Fold) :- phrases_between_target_args(ExampleID, Fold, Count), Count > 2, Count =< 5.
many_phrases_between_target_args(ExampleID, Fold) :- phrases_between_target_args(ExampleID, Fold, Count), Count > 5.

few_phrases_after_target_args(   ExampleID, Fold) :- phrases_after_target_args(  ExampleID, Fold, Count), Count > 0, Count =< 2.
some_phrases_after_target_args(  ExampleID, Fold) :- phrases_after_target_args(  ExampleID, Fold, Count), Count > 2, Count =< 5.
many_phrases_after_target_args(  ExampleID, Fold) :- phrases_after_target_args(  ExampleID, Fold, Count), Count > 5.

few_words_before_target_args(    ExampleID, Fold) :- words_before_target_args(   ExampleID, Fold, Count), Count > 0, Count =< 3.
some_words_before_target_args(   ExampleID, Fold) :- words_before_target_args(   ExampleID, Fold, Count), Count > 3, Count =< 9.
many_words_before_target_args(   ExampleID, Fold) :- words_before_target_args(   ExampleID, Fold, Count), Count > 9.

few_words_between_target_args(   ExampleID, Fold) :- words_between_target_args(  ExampleID, Fold, Count), Count > 0, Count =< 3.
some_words_between_target_args(  ExampleID, Fold) :- words_between_target_args(  ExampleID, Fold, Count), Count > 3, Count =< 9.
many_words_between_target_args(  ExampleID, Fold) :- words_between_target_args(  ExampleID, Fold, Count), Count > 9.

few_words_after_target_args(     ExampleID, Fold) :- words_after_target_args(    ExampleID, Fold, Count), Count > 0, Count =< 3.
some_words_after_target_args(    ExampleID, Fold) :- words_after_target_args(    ExampleID, Fold, Count), Count > 3, Count =< 9.
many_words_after_target_args(    ExampleID, Fold) :- words_after_target_args(    ExampleID, Fold, Count), Count > 9.

:- modeb(1, adjacent_target_args(            +example, +dataset, #fold)).
:- modeb(1, identical_target_args(           +example, +dataset, #fold)).

:- modeb(1, few_phrases_before_target_args(  +example, +dataset, #fold)).
:- modeb(1, some_phrases_before_target_args( +example, +dataset, #fold)).
:- modeb(1, many_phrases_before_target_args( +example, +dataset, #fold)).
:- modeb(1, few_phrases_between_target_args( +example, +dataset, #fold)).
:- modeb(1, some_phrases_between_target_args(+example, +dataset, #fold)).
:- modeb(1, many_phrases_between_target_args(+example, +dataset, #fold)).
:- modeb(1, few_phrases_after_target_args(   +example, +dataset, #fold)).
:- modeb(1, some_phrases_after_target_args(  +example, +dataset, #fold)).
:- modeb(1, many_phrases_after_target_args(  +example, +dataset, #fold)).

:- modeb(1, few_words_before_target_args(    +example, +dataset, #fold)).
:- modeb(1, some_words_before_target_args(   +example, +dataset, #fold)).
:- modeb(1, many_words_before_target_args(   +example, +dataset, #fold)).
:- modeb(1, few_words_between_target_args(   +example, +dataset, #fold)).
:- modeb(1, some_words_between_target_args(  +example, +dataset, #fold)).
:- modeb(1, many_words_between_target_args(  +example, +dataset, #fold)).
:- modeb(1, few_words_after_target_args(     +example, +dataset, #fold)).
:- modeb(1, some_words_after_target_args(    +example, +dataset, #fold)).
:- modeb(1, many_words_after_target_args(    +example, +dataset, #fold)).

/*

to do's: average phrase length?  any other aggregations?

*/


position_in_abstract(Sentence, SentenceNumber) :-
	break_down_sentence_token(Sentence, SentenceNumber, _).

short_abstract(Abstract) :-
	abstract(Abstract),
	number_sentences_in_abstract(Abstract, Count),
	Count < 5.
medium_abstract(Abstract) :-
	abstract(Abstract),
	number_sentences_in_abstract(Abstract, Count),
	Count > 4, Count < 10.
long_abstract(Abstract) :-
	abstract(Abstract),
	number_sentences_in_abstract(Abstract, Count),
	Count > 9.

:- modeb(1, first_sentence_in_abstract( -abstract, +sentence)).
:- modeb(1, middle_sentence_in_abstract(-abstract, +sentence)).
:- modeb(1, last_sentence_in_abstract(  -abstract, +sentence)).

:- modeb(1, short_abstract(+abstract)).
:- modeb(1, medium_abstract(+abstract)).
:- modeb(1, long_abstract(+abstract)).

set_sentence_properties_determinations(Head) :- 
   
   determination(Head, first_sentence_in_abstract/2),
   determination(Head, middle_sentence_in_abstract/2),
   determination(Head, last_sentence_in_abstract/2),
   determination(Head, short_abstract/1),
   determination(Head, medium_abstract/1),
   determination(Head, long_abstract/1),

   determination(Head, adjacent_target_args/2),
   determination(Head, identical_target_args/2),

   determination(Head, few_phrases_before_target_args/2),
   determination(Head, some_phrases_before_target_args/2),
   determination(Head, many_phrases_before_target_args/2),
   determination(Head, few_phrases_between_target_args/2),
   determination(Head, some_phrases_between_target_args/2),
   determination(Head, many_phrases_between_target_args/2),
   determination(Head, few_phrases_after_target_args/2),
   determination(Head, some_phrases_after_target_args/2),
   determination(Head, many_phrases_after_target_args/2),

   determination(Head, few_words_before_target_args/2),
   determination(Head, some_words_before_target_args/2),
   determination(Head, many_words_before_target_args/2),
   determination(Head, few_words_between_target_args/2),
   determination(Head, some_words_between_target_args/2),
   determination(Head, many_words_between_target_args/2),
   determination(Head, few_words_after_target_args/2),
   determination(Head, some_words_after_target_args/2),
   determination(Head, many_words_after_target_args/2),

   determination(Head, short_phrase/1),
   determination(Head, medium_phrase/1),
   determination(Head, long_phrase/1),

   determination(Head, short_sentence/1),
   determination(Head, avg_length_sentence/1),
   determination(Head, long_sentence/1),

   determination(Head, few_phrases_in_sentence/1),
   determination(Head, several_phrases_in_sentence/1),
   determination(Head, many_phrases_in_sentence/1),

   determination(Head, no_POS_in_phrase/2),
   determination(Head, one_POS_in_phrase/2),
   determination(Head, few_POS_in_phrase/2),
   determination(Head, some_POS_in_phrase/2),
   determination(Head, many_POS_in_phrase/2),

   determination(Head, no_wordPOS_in_sentence/2),
   determination(Head, one_wordPOS_in_sentence/2),
   determination(Head, few_wordPOS_in_sentence/2),
   determination(Head, some_wordPOS_in_sentence/2),
   determination(Head, many_wordPOS_in_sentence/2),

   determination(Head, no_phrasePOS_in_sentence/2),
   determination(Head, one_phrasePOS_in_sentence/2),
   determination(Head, few_phrasePOS_in_sentence/2),
   determination(Head, some_phrasePOS_in_sentence/2),
   determination(Head, many_phrasePOS_in_sentence/2),
   
   true.
